<?php

/**
 * This is the Cubrid database abstraction layer.
 *
 * @package MediaWiki
 */

class DatabaseCubrid extends Database {
	var $mInsertId = NULL;
	var $ignore_flag = false;
	var $mLastResult = NULL;
	var $debug_cubrid = false;
	var $cubint = Array();
	function DatabaseCubrid($server = false, $user = false, $password = false, $dbName = false,
		$failFunction = false, $flags = 0 )
	{
  	global $cubint;
		global $wgOut;
		# Can't get a reference if it hasn't been set yet
		if ( !isset( $wgOut ) ) {
			$wgOut = NULL;
		}
		$this->mOut =& $wgOut;
		$this->mFailFunction = $failFunction;
		$this->mCascadingDeletes = true;
		$this->mCleanupTriggers = true;
		$this->mStrictIPs = true;
		$this->mFlags = $flags;
		$this->open( $server, $user, $password, $dbName);
$cubint[] = 'AR_DELETED';
$cubint[] = 'AR_LEN';
$cubint[] = 'AR_MINOR_EDIT';
$cubint[] = 'AR_NAMESPACE';
$cubint[] = 'AR_REV_ID';
$cubint[] = 'AR_TEXT_ID';
$cubint[] = 'AR_USER';
$cubint[] = 'CL_FROM';
$cubint[] = 'EL_FROM';
$cubint[] = 'FA_BITS';
$cubint[] = 'FA_DELETED';
$cubint[] = 'FA_DELETED_USER';
$cubint[] = 'FA_HEIGHT';
$cubint[] = 'FA_ID';
$cubint[] = 'FA_SIZE';
$cubint[] = 'FA_USER';
$cubint[] = 'FA_WIDTH';
$cubint[] = 'HC_ID';
$cubint[] = 'IL_FROM';
$cubint[] = 'IMG_BITS';
$cubint[] = 'IMG_HEIGHT';
$cubint[] = 'IMG_SIZE';
$cubint[] = 'IMG_USER';
$cubint[] = 'IMG_WIDTH';
$cubint[] = 'IPB_ANON_ONLY';
$cubint[] = 'IPB_AUTO';
$cubint[] = 'IPB_BY';
$cubint[] = 'IPB_CREATE_ACCOUNT';
$cubint[] = 'IPB_DELETED';
$cubint[] = 'IPB_ENABLE_AUTOBLOCK';
$cubint[] = 'IPB_ID';
$cubint[] = 'IPB_USER';
$cubint[] = 'IW_LOCAL';
$cubint[] = 'IW_TRANS';
$cubint[] = 'JOB_ID';
$cubint[] = 'JOB_NAMESPACE';
$cubint[] = 'LL_FROM';
$cubint[] = 'LOG_DELETED';
$cubint[] = 'LOG_ID';
$cubint[] = 'LOG_NAMESPACE';
$cubint[] = 'LOG_USER';
$cubint[] = 'MATH_HTML_CONSERVATIVENESS';
$cubint[] = 'OI_BITS';
$cubint[] = 'OI_HEIGHT';
$cubint[] = 'OI_SIZE';
$cubint[] = 'OI_USER';
$cubint[] = 'OI_WIDTH';
$cubint[] = 'OLD_ID';
$cubint[] = 'PAGE_COUNTER';
$cubint[] = 'PAGE_ID';
$cubint[] = 'PAGE_IS_NEW';
$cubint[] = 'PAGE_IS_REDIRECT';
$cubint[] = 'PAGE_LATEST';
$cubint[] = 'PAGE_LEN';
$cubint[] = 'PAGE_NAMESPACE';
$cubint[] = 'PL_FROM';
$cubint[] = 'PL_NAMESPACE';
$cubint[] = 'PR_CASCADE';
$cubint[] = 'PR_EXPIRY';
$cubint[] = 'PR_ID';
$cubint[] = 'PR_PAGE';
$cubint[] = 'PR_USER';
$cubint[] = 'QCC_NAMESPACE';
$cubint[] = 'QCC_NAMESPACETWO';
$cubint[] = 'QCC_VALUE';
$cubint[] = 'QC_NAMESPACE';
$cubint[] = 'QC_VALUE';
$cubint[] = 'RC_BOT';
$cubint[] = 'RC_CUR_ID';
$cubint[] = 'RC_DELETED';
$cubint[] = 'RC_ID';
$cubint[] = 'RC_LAST_OLDID';
$cubint[] = 'RC_LOGID';
$cubint[] = 'RC_MINOR';
$cubint[] = 'RC_MOVED_TO_NS';
$cubint[] = 'RC_NAMESPACE';
$cubint[] = 'RC_NEW';
$cubint[] = 'RC_NEW_LEN';
$cubint[] = 'RC_OLD_LEN';
$cubint[] = 'RC_PATROLLED';
$cubint[] = 'RC_THIS_OLDID';
$cubint[] = 'RC_TYPE';
$cubint[] = 'RC_USER';
$cubint[] = 'RD_FROM';
$cubint[] = 'RD_NAMESPACE';
$cubint[] = 'REV_DELETED';
$cubint[] = 'REV_ID';
$cubint[] = 'REV_LEN';
$cubint[] = 'REV_MINOR_EDIT';
$cubint[] = 'REV_PAGE';
$cubint[] = 'REV_PARENT_ID';
$cubint[] = 'REV_TEXT_ID';
$cubint[] = 'REV_USER';
$cubint[] = 'SI_PAGE';
$cubint[] = 'SS_ADMINS';
$cubint[] = 'SS_GOOD_ARTICLES';
$cubint[] = 'SS_IMAGES';
$cubint[] = 'SS_ROW_ID';
$cubint[] = 'SS_TOTAL_EDITS';
$cubint[] = 'SS_TOTAL_PAGES';
$cubint[] = 'SS_TOTAL_VIEWS';
$cubint[] = 'SS_USERS';
$cubint[] = 'TB_ID';
$cubint[] = 'TB_PAGE';
$cubint[] = 'TC_TIME';
$cubint[] = 'TL_FROM';
$cubint[] = 'TL_NAMESPACE';
$cubint[] = 'UG_USER';
$cubint[] = 'USER_EDITCOUNT';
$cubint[] = 'USER_ID';
$cubint[] = 'WL_NAMESPACE';
$cubint[] = 'WL_USER';
	}

	function realTimestamps() {
		return true;
	}

	function implicitGroupby() {
		return false;
	}

	static function newFromParams( $server = false, $user = false, $password = false, $dbName = false,
		$failFunction = false, $flags = 0)
	{
		return new DatabaseCubrid( $server, $user, $password, $dbName, $failFunction, $flags );
	}

	/**
	 * Usually aborts on failure
	 * If the failFunction is set to a non-zero integer, returns success
	 */
	function open( $server, $user, $password, $dbName ) {
		# Test for Cubrid support, to avoid suppressed fatal error
		if ( !function_exists( 'cubrid_connect' ) ) {
			throw new DBConnectionError( $this, "Cubrid functions missing!!!\n (Note: if you recently installed PHP, you may need to restart your webserver and database)\n" );
		}

		global $wgDBport;

		$this->close();
		$this->mServer = $server;
		$port = $wgDBport;
		$this->mUser = $user;
		$this->mPassword = $password;
		$this->mDBname = $dbName;

		if (!strlen($user)) { ## e.g. the class is being loaded
			return;
		}

		error_reporting( E_ALL );
		@$this->mConn = cubrid_connect($server, $port, $dbName, $user, $password);

		if ( $this->mConn == false ) {
			wfDebug( "DB connection error\n" );
			wfDebug( "Server: $server, Database: $dbName, User: $user, Password: " . substr( $password, 0, 3 ) . "...\n" );
			wfDebug( $this->lastError()."\n" );
			return false;
		}

		$this->mOpened = true;

		return $this->mConn;
	}

	/**
	 * Closes a database connection, if it is open
	 * Returns success, true if already closed
	 */
	function close() {
		$this->mOpened = false;
		if ( $this->mConn ) {
			return cubrid_disconnect( $this->mConn );
		} else {
			return true;
		}
	}

	function query( $sql, $fname = '', $tempIgnore = false ) {
		$this->mLastQuery = $sql;

		# If DBO_TRX is set, start a transaction
		if ( ( $this->mFlags & DBO_TRX ) && !$this->trxLevel() && 
			$sql != 'BEGIN' && $sql != 'COMMIT' && $sql != 'ROLLBACK') {
			$this->begin();
		}

		if ( $this->debug() ) {
			$sqlx = substr( $sql, 0, 500 );
			$sqlx = strtr( $sqlx, "\t\n", '  ' );
			wfDebug( "SQL: $sqlx\n" );
		}

		return $this->doQuery( $sql );
	}

	function doQuery( $sql ) {
		if ($this->debug_cubrid === true)
		  echo($this->backtrace()."<br>\n".$sql); //@@@
		$this->mLastResult=cubrid_execute( $this->mConn , $sql);
		if (cubrid_error_code()!=0 && $this->ignore_flag!==true) {
		  echo $sql."))";
		  throw new DBUnexpectedError($this,  'SQL error: ' . htmlspecialchars( cubrid_error_msg() ) );
		}
		
		if ($this->ignore_flag===true) {
		  return true;
		}
		return $this->mLastResult;
	}

	function queryIgnore( $sql, $fname = '' ) {
		return $this->query( $sql, $fname, true );
	}

	function freeResult( $res ) {
		cubrid_close_request( $res );
	}

	function fetchObject( $res ) {
		if (!($row = cubrid_fetch($res))) {
		  if (cubrid_error_code()!=0)
			  throw new DBUnexpectedError($this,  'SQL error: ' . htmlspecialchars( cubrid_error_msg() ) );
			else
			  return null;
		}
		
		return ((object)$row);
	}

	function fetchRow( $res ) {
		if (!($row = cubrid_fetch( $res ))) {
 		  if (cubrid_error_code()!=0)
  			throw new DBUnexpectedError($this,  'SQL error: ' . htmlspecialchars( cubrid_error_msg() ) );
			else
			  return null;
		}
		return $row;
	}

	function numRows( $res ) {
		@$n = cubrid_num_rows( $res ) + 0;
		return $n;
	}
	
	function numFields( $res ) { return cubrid_num_cols( $res ); }
	
	function fieldName( $res, $n ) {
	  $ary = cubrid_column_names($res);
	  return $ary[$n]; 
	}

	/**
	 * This must be called after nextSequenceVal
	 */
	function insertId() {
		return $this->mInsertId;
	}

	function dataSeek( $res, $row ) { 
	  return cubrid_move_cursor($res, $row+1, CUBRID_CURSOR_FIRST); 
	}
	
	function lastError() {
		if ( $this->mConn ) {
			return cubrid_error_msg();
		}
		else {
			return "No database connection";
		}
	}
	function lastErrno() {
		return cubrid_error_code();
	}

	function affectedRows() {
		return cubrid_affected_rows( $this->mLastResult );
	}

	function indexInfo( $table, $index) {
		$sql = "SELECT * FROM db_index WHERE class_name='$table' and index_name='$index'";
		$res = $this->query( $sql );
		if ( !$res ) {
			return NULL;
		}

		$result = array();
		if ( $row = $this->fetchObject( $res ) )
			$result[] = $row;
		$this->freeResult($res);

		return empty($result) ? false : $result;
	}

	function indexUnique ($table, $index) {
		$indexInfo = $this->indexInfo( $table, $index );
		if ($indexInfo===false || $indexInfo==NULL) {
			return NULL;
		}
		if ($indexInfo[0]->is_unique == "YES")
		  return true;
		else
		  return false;
	}

	function insert( $table, $a, $fname = 'Database::insert', $options = array() ) {
		# Cubrid doesn't support options & multi row insert
		# [LOW_PRIORITY | DELAYED | HIGH_PRIORITY] [IGNORE]

		if ( !is_array($options))
			$options = array($options);

		if ( !is_array( reset( $a ) ) ) {
			$a = array( $a );
		}
		if ( in_array( 'IGNORE', $options ) ) {
  		$this->ignore_flag = true;
  	}
		foreach ( $a as $row ) {
			$retVal = parent::insert( $table, $row, $fname, array() );
		}

		if ( in_array( 'IGNORE', $options ) ) {
  		$this->ignore_flag = false;
  		$retVal = true;
  	}

		return $retVal;
	}

	function tableName( $name ) {
		if ( $this->mTablePrefix !== '' &&  strpos( '.', $name ) === false ) {
			$name = "{$this->mTablePrefix}$name";
		}
		# Replace reserved words with better ones
		switch( $name ) {
			case 'user':
				return 'mwuser';
			case 'image':
				return 'imagebase';
			default:
				return $name;
		}
	}

	/**
	 * Return the next in a sequence, save the value for retrieval via insertId()
	 */
	function nextSequenceValue( $seqName ) {
		$res = $this->query( "select $seqName".".next_value FROM serial_base" );
		$row = $this->fetchRow( $res );
		$this->mInsertId = $row[0];
		$this->freeResult( $res );
		return $this->mInsertId;
	}

	function useIndexClause( $index ) {
		return "USING INDEX $index";
	}

	# REPLACE query wrapper
	# Cubrid simulates this with a DELETE followed by INSERT
	# $row is the row to insert, an associative array
	# $uniqueIndexes is an array of indexes.
	function replace( $table, $uniqueIndexes, $rows, $fname = 'Database::replace' ) {
		$table = $this->tableName( $table );

		if (count($rows)==0) {
			return;
		}

		# Single row case
		if ( !is_array( reset( $rows ) ) ) {
			$rows = array( $rows );
		}

		foreach( $rows as $row ) {
			# Delete rows which collide
			if ( $uniqueIndexes ) {
				$sql = "DELETE FROM $table WHERE ";
				$first = true;
				foreach ( $uniqueIndexes as $index ) {
					if ( $first ) {
						$first = false;
						$sql .= "(";
					} else {
						$sql .= ') OR (';
					}
					if ( is_array( $index ) ) {
						$first2 = true;
						foreach ( $index as $col ) {
							if ( $first2 ) {
								$first2 = false;
							} else {
								$sql .= ' AND ';
							}
							$sql .= $col.'=' . $this->addQuotes( $row[$col] );
						}
					} else {
						$sql .= $index.'=' . $this->addQuotes( $row[$index] );
					}
				}
				$sql .= ')';
				$this->query( $sql, $fname );
			}

			# Now insert the row
			$sql = "INSERT INTO $table (" . $this->makeList( array_keys( $row ), LIST_NAMES ) .') VALUES (' .
				$this->makeList( $row, LIST_COMMA ) . ')';
			$this->query( $sql, $fname );
		}
	}

	# DELETE where the condition is a join
	function deleteJoin( $delTable, $joinTable, $delVar, $joinVar, $conds, $fname = "Database::deleteJoin" ) {
		if ( !$conds ) {
			throw new DBUnexpectedError($this,  'Database::deleteJoin() called with empty $conds' );
		}

		$delTable = $this->tableName( $delTable );
		$joinTable = $this->tableName( $joinTable );
		$sql = "DELETE FROM $delTable WHERE $delVar IN (SELECT $joinVar FROM $joinTable ";
		if ( $conds != '*' ) {
			$sql .= 'WHERE ' . $this->makeList( $conds, LIST_AND );
		}
		$sql .= ')';

		$this->query( $sql, $fname );
	}

	function textFieldSize( $table, $field ) {
		$table = $this->tableName( $table );
		$sql = "select prec from db_attribute where class_name='$table' and attr_name='$field'";
		$res =$this->query($sql);
		$row=$this->fetchObject($res);
		$size=$row->prec;
		$this->freeResult( $res );
		return $size;
	}

	function lowPriorityOption() {
		return '';
	}

	function limitResult($sql, $limit, $offset=false) {
		if( !is_numeric($limit) ) {
			throw new DBUnexpectedError( $this, "Invalid non-numeric limit passed to limitResult()\n" );
		}
    if (is_numeric($offset) && $offset>0) {
      $lmstr=" BETWEEN ".($limit+1)." AND ".($limit+$offset);
    }
    else {
      $lmstr=" BETWEEN 1 AND $limit";
    }
    
    $sqlupr = strtoupper($sql);
    if (strpos($sqlupr,"ORDER BY") !== false) { // for orderby_num() between.. and ..
      $sql .= " for orderby_num() ".$lmstr;
    }
    else {
      if (strpos($sqlupr,"GROUP BY") !== false) { // having groupby_num() between.. and .. 
        if (($pos=strpos($sqlupr,"HAVING")) !== false) { // AND ...
          $sql = substr($sql,0,$pos+6)." groupby_num() ".$lmstr." and ".substr($sql,$pos+6);
        }
        else { // having ...
          $sql .= " having groupby_num() ".$lmstr;
        }
      }
      else { //where inst_num() between.. and .. 
        if (($pos=strpos($sqlupr,"WHERE")) !== false) { // AND ...
          $sql = substr($sql,0,$pos+5)." inst_num() ".$lmstr." and ".substr($sql,$pos+5);
        }
        else { // where ...
          $sql .= " where inst_num() ".$lmstr;
        }
      }
    }
		return $sql;
	}

	function limitResultCond($cond, $limit,$offset) {
    if (is_numeric($offset)) {
      $fld="ROWNUM BETWEEN ".($limit+1)." AND ";
      $cond['$fld']=($limit+$offset);
    }
    else {
      $cond['ROWNUM < ']=($limit+1); 
    }
	}

	/**
	 * Returns an SQL expression for a simple conditional.
	 * Uses CASE on Postgres
	 *
	 * @param string $cond SQL expression which will result in a boolean value
	 * @param string $trueVal SQL expression to return if true
	 * @param string $falseVal SQL expression to return if false
	 * @return string SQL fragment
	 */
	function conditional( $cond, $trueVal, $falseVal ) {
		return " (CASE WHEN $cond THEN $trueVal ELSE $falseVal END) ";
	}

	function wasDeadlock() {
	  //ER_LK_UNILATERALLY_ABORTED
		return $this->lastErrno() == -72;
	}

	function timestamp( $ts=0 ) {
		return wfTimestamp(TS_CUBRID,$ts);
	}

	/**
	 * Return aggregated value function call
	 */
	function aggregateValue ($valuedata,$valuename='value') {
		return $valuedata;
	}


	function reportQueryError( $error, $errno, $sql, $fname, $tempIgnore = false ) {
		# Ignore errors during error handling to avoid infinite recursion
		$ignore = $this->ignoreErrors( true );
		++$this->mErrorCount;

		if ($ignore || $tempIgnore) {
			wfDebug("SQL ERROR (ignored): $error\n");
			$this->ignoreErrors( $ignore );
		}
		else {
			$message = "A database error has occurred\n" .
				"Query: $sql\n" .
				"Function: $fname\n" .
				"Error: $errno $error\n";
			throw new DBUnexpectedError($this, $message);
		}
	}

	/**
	 * @return string wikitext of a link to the server software's web site
	 */
	function getSoftwareLink() {
		return "[http://www.cubrid.com/ CUBRID]";
	}

	/**
	 * @return string Version information from the database
	 */
	function getServerVersion() {
    #CUBRID not support get DBMS version. 6.6 is minimum version
		return "6.6 or above";
	}


	/**
	 * Query whether a given table exists (in the given schema, or the default mw one if not given)
	 */
	function tableExists( $table ) {
	  $table = $this->tableName( $table );
		$SQL = "SELECT 1 FROM db_class WHERE class_name = '$table'";
		$res = $this->query( $SQL );
		$count = $res ? cubrid_num_rows($res) : 0;
		if ($res)
			$this->freeResult( $res );
		return $count;
	}

	/**
	 * Query whether a given column exists in the mediawiki schema
	 */
	function fieldExists( $table, $field ) {
	  $table = $this->tableName( $table );
		$SQL = "SELECT 1 FROM db_attribute WHERE class_name='$table' AND attr_name='$field'";
		$res = $this->query( $SQL );
		$count = $res ? cubrid_num_rows($res) : 0;
		if ($res)
			$this->freeResult( $res );
		return $count;
	}

	function fieldInfo( $table, $field ) {
	  $table = $this->tableName( $table );
		$res = $this->query( "SELECT $field FROM $table WHERE rownum=1" );
		$type=cubrid_column_types($res);
		return $type[0];
	}

	function begin( $fname = 'DatabasePostgrs::begin' ) {
		$this->mTrxLevel = 1;
	}
	
	function immediateCommit() {
	  cubrid_commit($this->mConn);
		return true;
	}
	
	function commit() {
		cubrid_commit($this->mConn);
		$this->mTrxLevel = 0;
	}

	function rollback() {
		cubrid_rollback($this->mConn);
		$this->mTrxLevel = 0;
	}

	/* Not even sure why this is used in the main codebase... */
	function limitResultForUpdate($sql, $num) {
		return $sql;
	}

	function setup_database() {
		global $wgVersion, $wgDBmwschema, $wgDBts2schema, $wgDBport;

		dbsource( "../maintenance/cubrid/tables.sql", $this);

		## Update version information
		$mwv = $this->addQuotes($wgVersion);
		$pgv = $this->addQuotes($this->getServerVersion());
		$pgu = $this->addQuotes($this->mUser);
		$mws = $this->addQuotes($wgDBmwschema);
		$tss = $this->addQuotes($wgDBts2schema);
		$pgp = $this->addQuotes($wgDBport);
		$dbn = $this->addQuotes($this->mDBname);
		$ctype = "ko.KR";

		## Avoid the non-standard "REPLACE INTO" syntax
		$f = fopen( "../maintenance/interwiki.sql", 'r' );
		if ($f == false ) {
			dieout( "<li>Could not find the interwiki.sql file");
		}
		## We simply assume it is already empty as we have just created it
		$SQL = "INSERT INTO interwiki(iw_prefix,iw_url,iw_local) VALUES ";
		while ( ! feof( $f ) ) {
			$line = fgets($f,1024);
			$matches = array();
			if (!preg_match('/^\s*(\(.+?),(\d)\)/', $line, $matches)) {
				continue;
			}
			$this->query("$SQL $matches[1],$matches[2])");
		}

		print " (table interwiki successfully populated)...\n";
	}

	function encodeBlob($b) {
//		return eregi_replace(chr(39), chr(39).chr(39),$b);
		return $b;
	}
	function decodeBlob($b) {
		return $b;
	}

	function strencode( $s ) { ## Should not be called by us
		return eregi_replace(chr(39), chr(39).chr(39),$s);
	}

	function addQuotes( $s ) {
		if ( is_null( $s ) ) {
			return 'NULL';
		} else if (is_array( $s )) { ## Assume it is bytea data
			return "E'$s[1]'";
		}
		
    $cutlen=15000;
    $clen=strlen($s);
    if ($clen<=$cutlen)
      return "'" . eregi_replace(chr(39), chr(39).chr(39),$s) . "'";
    else {
      $wrk="";
      $off=0;
      while($off<$clen) {
        $wlen=$clen-$off;
        if ($wlen>$cutlen) $wlen=$cutlen;
        if ($off>0) $wrk .= ' + ';
        $wrk .= chr(39).eregi_replace(chr(39), chr(39).chr(39), substr($s, $off, $wlen)).chr(39);
        $off += $wlen;
      }
      return $wrk;
    }
	}

	function quote_ident( $s ) {
		return '"' . preg_replace( '/"/', '""', $s) . '"';
	}

	/* For now, does nothing */
	function selectDB( $db ) {
		return true;
	}

	/**
	 * Returns an optional USE INDEX clause to go after the table, and a
	 * string to go at the end of the query
	 *
	 * @private
	 *
	 * @param array $options an associative array of options to be turned into
	 *              an SQL query, valid keys are listed in the function.
	 * @return array
	 */
	function makeSelectOptions( $options ) {
		$tailOpts = '';
		$startOpts = '';

		$noKeyOptions = array();
		foreach ( $options as $key => $option ) {
			if ( is_numeric( $key ) ) {
				$noKeyOptions[$option] = true;
			}
		}

		if ( isset( $noKeyOptions['DISTINCT'] )) $startOpts .= 'DISTINCT';
	
		if ( isset( $options['GROUP BY'] ) ) $tailOpts .= " GROUP BY {$options['GROUP BY']}";
		if ( isset( $options['ORDER BY'] ) ) $tailOpts .= " ORDER BY {$options['ORDER BY']}";

		if ( isset( $options['USE INDEX'] ) && ! is_array( $options['USE INDEX'] ) ) {
			$useIndex = $this->useIndexClause( $options['USE INDEX'] );
		} else {
			$useIndex = '';
		}
		
		return array( $startOpts, $useIndex, $tailOpts );
	}

	function ping() {
		wfDebug( "Function ping() not written for DatabasePostgres.php yet");
		return true;
	}

  function is_cubrid_numeric( $name )
  {
  	global $cubint;
  	
  	if( in_array( strtoupper( $name ), $cubint ) )
  	{
  		return true;
  	}
  	else
  	{
  		return false;
  	}
  
  }


	/**
	 * Makes an encoded list of strings from an array
	 * $mode:
	 *        LIST_COMMA         - comma separated, no field names
	 *        LIST_AND           - ANDed WHERE clause (without the WHERE)
	 *        LIST_OR            - ORed WHERE clause (without the WHERE)
	 *        LIST_SET           - comma separated with field names, like a SET clause
	 *        LIST_NAMES         - comma separated field names
	 */
	function makeList( $a, $mode = LIST_COMMA ) {
		if ( !is_array( $a ) ) {
			throw new DBUnexpectedError( $this, 'Database::makeList called with incorrect parameters' );
		}

		$first = true;
		$list = '';
		foreach ( $a as $field => $value ) {
			if ( !$first ) {
				if ( $mode == LIST_AND ) {
					$list .= ' AND ';
				} elseif($mode == LIST_OR) {
					$list .= ' OR ';
				} else {
					$list .= ',';
				}
			} else {
				$first = false;
			}
			if ( ($mode == LIST_AND || $mode == LIST_OR) && is_numeric( $field ) ) {
				$list .= "($value)";
			} elseif ( ($mode == LIST_SET) && is_numeric( $field ) ) {
				$list .= "$value";
			} elseif ( ($mode == LIST_AND || $mode == LIST_OR) && is_array ($value) ) {
				$list .= $field." IN (".$this->makeList($value).") ";
			} else {
				if ( $mode == LIST_AND || $mode == LIST_OR || $mode == LIST_SET ) {
					$list .= "$field = ";
				}
				if ($mode == LIST_NAMES) {
				  $list .= $value;
				}
				else {
				  if ($this->is_cubrid_numeric( $field )) {
				    $value += 0;
  				  $list .= $value;
  				}
  				else
  				  $list .= $this->addQuotes( $value );
				}
			}
		}
		
		return $list;
	}

	function insertSelect( $destTable, $srcTable, $varMap, $conds, $fname,
		$insertOptions = array(), $selectOptions = array() )
	{
		if (isset($options['LIMIT'])) {
			$this->limitResultCond($conds, $options['LIMIT'],
				isset($options['OFFSET']) ? $options['OFFSET'] : false);
		}
		
		$ret = parent::insertSelect( $destTable, $srcTable, $varMap, $conds, $fname, $insertOptions, $selectOptions);
		return $ret;
	}

	function select( $table, $vars, $conds='', $fname, $options = array() )
	{
		if (isset($options['LIMIT'])) {
			$this->limitResultCond($conds, $options['LIMIT'],
				isset($options['OFFSET']) ? $options['OFFSET'] : false);
		}

		if( is_array( $vars ) ) {
			$vars = implode( ',', $vars );
		}
		if( !is_array( $options ) ) {
			$options = array( $options );
		}
		if( is_array( $table ) ) {
			if ( isset( $options['USE INDEX'] ) && is_array( $options['USE INDEX'] ) )
				$from = ' FROM ' . $this->tableNamesWithUseIndex( $table, $options['USE INDEX'] );
			else
				$from = ' FROM ' . implode( ',', array_map( array( &$this, 'tableName' ), $table ) );
		} elseif ($table!='') {
			$from = ' FROM ' . $this->tableName( $table );
		} else {
			$from = '';
		}

		list( $startOpts, $useIndex, $tailOpts ) = $this->makeSelectOptions( $options );

		if( !empty( $conds ) ) {
			if ( is_array( $conds ) ) {
				$conds = $this->makeList( $conds, LIST_AND );
			}
			$sql = "SELECT $startOpts $vars $from WHERE $conds  $useIndex $tailOpts";
		} else {
			$sql = "SELECT $startOpts $vars $from $useIndex $tailOpts";
		}

		return $this->query( $sql);
	}

  function backtrace()
  {
      $output = "<div style='text-align: left;'>\n";
      $output .= "<b>Backtrace:</b><br />\n";
      $backtrace = debug_backtrace();
  
      foreach ($backtrace as $bt) {
          $args = '';
          foreach ($bt['args'] as $a) {
              if (!empty($args)) {
                  $args .= ', ';
              }
              switch (gettype($a)) {
              case 'integer':
              case 'double':
                  $args .= $a;
                  break;
              case 'string':
                  $a = htmlspecialchars(substr($a, 0, 64)).((strlen($a) > 64) ? '...' : '');
                  $args .= "\"$a\"";
                  break;
              case 'array':
                  $args .= 'Array('.count($a).')';
                  break;
              case 'object':
                  $args .= 'Object('.get_class($a).')';
                  break;
              case 'resource':
                  $args .= 'Resource('.strstr($a, '#').')';
                  break;
              case 'boolean':
                  $args .= $a ? 'True' : 'False';
                  break;
              case 'NULL':
                  $args .= 'Null';
                  break;
              default:
                  $args .= 'Unknown';
              }
          }
          $output .= "<br />\n";
          $output .= "<b>file:</b> {$bt['line']} - {$bt['file']}<br />\n";
          $output .= "<b>call:</b> {$bt['class']}{$bt['type']}{$bt['function']}($args)<br />\n";
      }
      $output .= "</div>\n";
      return $output;
  }

} // end DatabasePostgres class

?>
