<?php
/**
 *
 * @addtogroup SpecialPage
 */

/**
 * Implements Special:Ancientpages
 * @addtogroup SpecialPage
 */
class AncientPagesPage extends QueryPage {

	function getName() {
		return "Ancientpages";
	}

	function isExpensive() {
		return true;
	}

	function isSyndicated() { return false; }

	function getSQL() {
		global $wgDBtype;
		$db = wfGetDB( DB_SLAVE );
		$page = $db->tableName( 'page' );
		$revision = $db->tableName( 'revision' );
		#$use_index = $db->useIndexClause( 'cur_timestamp' ); # FIXME! this is gone
		if ($wgDBtype == 'mysql') {
		  $epoch = 'UNIX_TIMESTAMP(rev_timestamp)';
		}
		else if ($wgDBtype == 'cubrid') {
			$epoch = "(rev_timestamp - timestamp '01/01/1970 09:00:00 am') + 28800";
		} else {
			$epoch = 'EXTRACT(epoch FROM rev_timestamp)';
		}
		return
			"SELECT 'Ancientpages' as typ,
					page_namespace as namespace,
			        page_title as title,
			        $epoch as valu
			FROM $page, $revision
			WHERE page_namespace=".NS_MAIN." AND page_is_redirect=0
			  AND page_latest=rev_id";
	}

	function sortDescending() {
		return false;
	}

	function formatResult( $skin, $result ) {
		global $wgLang, $wgContLang;

		$d = $wgLang->timeanddate( wfTimestamp( TS_MW, $result->valu ), true );
		$title = Title::makeTitle( $result->namespace, $result->title );
		$link = $skin->makeKnownLinkObj( $title, htmlspecialchars( $wgContLang->convert( $title->getPrefixedText() ) ) );
		return wfSpecialList($link, $d);
	}
}

function wfSpecialAncientpages() {
	list( $limit, $offset ) = wfCheckLimits();

	$app = new AncientPagesPage();

	$app->doQuery( $offset, $limit );
}

?>
