
CREATE TABLE /*$wgDBprefix*/archive
( ar_namespace INT DEFAULT 0   NOT NULL,
ar_title VARCHAR(255) DEFAULT ''   NOT NULL,
ar_text STRING DEFAULT ''   NOT NULL,
ar_comment STRING DEFAULT ''   NOT NULL,
ar_user INT DEFAULT 0   NOT NULL,
ar_user_text VARCHAR(255) DEFAULT ''   NOT NULL,
ar_timestamp TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL,
ar_minor_edit SMALLINT DEFAULT 0   NOT NULL,
ar_flags STRING DEFAULT ''   NOT NULL,
ar_rev_id INT DEFAULT 0  ,
ar_text_id INT DEFAULT 0  ,
ar_deleted SMALLINT DEFAULT 0   NOT NULL,
ar_len INT DEFAULT 0  
 ) 
;

CREATE TABLE /*$wgDBprefix*/categorylinks
( cl_from INT DEFAULT 0   NOT NULL,
cl_to VARCHAR(255) DEFAULT ''   NOT NULL,
cl_sortkey VARCHAR(86) DEFAULT ''   NOT NULL,
cl_timestamp TIMESTAMP NOT NULL  
 ) 
;

CREATE TABLE /*$wgDBprefix*/externallinks
( el_from INT DEFAULT 0   NOT NULL,
el_to STRING DEFAULT ''   NOT NULL,
el_index STRING DEFAULT ''   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/filearchive
( fa_id INT DEFAULT 0   NOT NULL,
fa_name VARCHAR(255) DEFAULT ''   NOT NULL,
fa_archive_name VARCHAR(255) DEFAULT ''  ,
fa_storage_group VARCHAR(16) DEFAULT ''  ,
fa_storage_key VARCHAR(64) DEFAULT ''  ,
fa_deleted_user INT DEFAULT 0  ,
fa_deleted_timestamp TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970',
fa_deleted_reason VARCHAR(65535) DEFAULT ''  ,
fa_size INT DEFAULT 0  ,
fa_width INT DEFAULT 0  ,
fa_height INT DEFAULT 0  ,
fa_metadata STRING DEFAULT ''  ,
fa_bits INT DEFAULT 0  ,
fa_media_type VARCHAR( 10 ) DEFAULT ''  ,
fa_major_mime VARCHAR( 11 ) DEFAULT 'unknown'  ,
fa_minor_mime VARCHAR(32) DEFAULT 'unknown'  ,
fa_description STRING DEFAULT ''  ,
fa_user INT DEFAULT 0  ,
fa_user_text VARCHAR(255) DEFAULT ''  ,
fa_timestamp TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970',
fa_deleted SMALLINT DEFAULT 0   NOT NULL 
 ) 
;
CREATE SERIAL /*$wgDBprefix*/filearchive_fa_id_seq START WITH 1;

CREATE TABLE /*$wgDBprefix*/hitcounter
( hc_id INT DEFAULT 0   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/imagebase
( img_name VARCHAR(255) DEFAULT ''   NOT NULL,
img_size INT DEFAULT 0   NOT NULL,
img_width INT DEFAULT 0   NOT NULL,
img_height INT DEFAULT 0   NOT NULL,
img_metadata STRING DEFAULT ''   NOT NULL,
img_bits INT DEFAULT 0   NOT NULL,
img_media_type VARCHAR( 10 ) DEFAULT ''  ,
img_major_mime VARCHAR( 11 ) DEFAULT 'unknown'   NOT NULL,
img_minor_mime VARCHAR(32) DEFAULT 'unknown'   NOT NULL,
img_description STRING DEFAULT ''   NOT NULL,
img_user INT DEFAULT 0   NOT NULL,
img_user_text VARCHAR(255) DEFAULT ''   NOT NULL,
img_timestamp TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/imagelinks
( il_from INT DEFAULT 0   NOT NULL,
il_to VARCHAR(255) DEFAULT ''   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/interwiki
( iw_prefix CHAR(32) DEFAULT ''   NOT NULL,
iw_url CHAR(127) DEFAULT ''   NOT NULL,
iw_local SMALLINT DEFAULT 0   NOT NULL,
iw_trans SMALLINT DEFAULT 0   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/ipblocks
( ipb_id INT DEFAULT 0   NOT NULL,
ipb_address STRING DEFAULT ''   NOT NULL,
ipb_user INT DEFAULT 0   NOT NULL,
ipb_by INT DEFAULT 0   NOT NULL,
ipb_reason STRING DEFAULT ''   NOT NULL,
ipb_timestamp TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL,
ipb_auto SMALLINT DEFAULT 0   NOT NULL,
ipb_anon_only SMALLINT DEFAULT 0   NOT NULL,
ipb_create_account SMALLINT DEFAULT 1   NOT NULL,
ipb_enable_autoblock SMALLINT DEFAULT 1   NOT NULL,
ipb_expiry TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL,
ipb_range_start STRING DEFAULT ''   NOT NULL,
ipb_range_end STRING DEFAULT ''   NOT NULL,
ipb_deleted SMALLINT DEFAULT 0   NOT NULL
 ) 
;
CREATE SERIAL /*$wgDBprefix*/ipblocks_ipb_id_val START WITH 1;

CREATE TABLE /*$wgDBprefix*/job
( job_id INT DEFAULT 0   NOT NULL,
job_cmd VARCHAR(255) DEFAULT ''   NOT NULL,
job_namespace INT DEFAULT 0   NOT NULL,
job_title VARCHAR(255) DEFAULT ''   NOT NULL,
job_params STRING DEFAULT ''   NOT NULL
 ) 
;
CREATE SERIAL /*$wgDBprefix*/job_job_id_seq START WITH 1;

CREATE TABLE /*$wgDBprefix*/langlinks
( ll_from INT DEFAULT 0   NOT NULL,
ll_lang VARCHAR(10) DEFAULT ''   NOT NULL,
ll_title VARCHAR(255) DEFAULT ''   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/logging
( log_type CHAR(10) DEFAULT ''   NOT NULL,
log_action CHAR(10) DEFAULT ''   NOT NULL,
log_timestamp TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL,
log_user INT DEFAULT 0   NOT NULL,
log_namespace INT DEFAULT 0   NOT NULL,
log_title VARCHAR(255) DEFAULT ''   NOT NULL,
log_comment VARCHAR(255) DEFAULT ''   NOT NULL,
log_params STRING DEFAULT ''   NOT NULL,
log_id INT DEFAULT 0   NOT NULL,
log_deleted SMALLINT DEFAULT 0   NOT NULL
 ) 
;

CREATE SERIAL /*$wgDBprefix*/logging_log_id_seq START WITH 1;

CREATE TABLE /*$wgDBprefix*/math
( math_inputhash VARCHAR(16) DEFAULT ''   NOT NULL,
math_outputhash VARCHAR(16) DEFAULT ''   NOT NULL,
math_html_conservativeness SMALLINT DEFAULT 0   NOT NULL,
math_html VARCHAR(65535) DEFAULT ''  ,
math_mathml VARCHAR(65535) DEFAULT ''  
 ) 
;

CREATE TABLE /*$wgDBprefix*/objectcache
( keyname CHAR(255) DEFAULT ''   NOT NULL,
valu STRING DEFAULT ''  ,
exptime TIMESTAMP  
 ) 
;

CREATE TABLE /*$wgDBprefix*/oldimage
( oi_name VARCHAR(255) DEFAULT ''   NOT NULL,
oi_archive_name VARCHAR(255) DEFAULT ''   NOT NULL,
oi_size INT DEFAULT 0   NOT NULL,
oi_width INT DEFAULT 0   NOT NULL,
oi_height INT DEFAULT 0   NOT NULL,
oi_bits INT DEFAULT 0   NOT NULL,
oi_description STRING DEFAULT ''   NOT NULL,
oi_user INT DEFAULT 0   NOT NULL,
oi_user_text VARCHAR(255) DEFAULT ''   NOT NULL,
oi_timestamp TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/page
( page_id INT DEFAULT 0   NOT NULL,
page_namespace INT DEFAULT 0   NOT NULL,
page_title VARCHAR(255) DEFAULT ''   NOT NULL,
page_restrictions STRING DEFAULT ''   NOT NULL,
page_counter NUMERIC DEFAULT 0   NOT NULL,
page_is_redirect SMALLINT DEFAULT 0   NOT NULL,
page_is_new SMALLINT DEFAULT 0   NOT NULL,
page_random VARCHAR DEFAULT ''   NOT NULL,
page_touched TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL,
page_latest INT DEFAULT 0   NOT NULL,
page_len INT DEFAULT 0   NOT NULL
 ) 
;
CREATE SERIAL /*$wgDBprefix*/page_page_id_seq START WITH 1;


CREATE TABLE /*$wgDBprefix*/page_restrictions
( pr_page INT DEFAULT 0   NOT NULL,
pr_type STRING DEFAULT ''   NOT NULL,
pr_level STRING DEFAULT ''   NOT NULL,
pr_cascade SMALLINT DEFAULT 0   NOT NULL,
pr_user INT DEFAULT 0  ,
pr_expiry TIMESTAMP,
pr_id INT DEFAULT 0   NOT NULL
 ) 
;
CREATE SERIAL /*$wgDBprefix*/page_restrictions_pr_id_seq START WITH 1;


CREATE TABLE /*$wgDBprefix*/pagelinks
( pl_from INT DEFAULT 0   NOT NULL,
pl_namespace INT DEFAULT 0   NOT NULL,
pl_title VARCHAR(255) DEFAULT ''   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/querycache
( qc_type CHAR(32) DEFAULT ''   NOT NULL,
qc_value INT DEFAULT 0   NOT NULL,
qc_namespace INT DEFAULT 0   NOT NULL,
qc_title CHAR(255) DEFAULT ''   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/querycache_info
( qci_type VARCHAR(32) DEFAULT ''   NOT NULL,
qci_timestamp TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/querycachetwo
( qcc_type CHAR(32) DEFAULT ''   NOT NULL,
qcc_value INT DEFAULT 0   NOT NULL,
qcc_namespace INT DEFAULT 0   NOT NULL,
qcc_title CHAR(255) DEFAULT ''   NOT NULL,
qcc_namespacetwo INT DEFAULT 0   NOT NULL,
qcc_titletwo CHAR(255) DEFAULT ''   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/recentchanges
( rc_id INT DEFAULT 0   NOT NULL,
rc_timestamp TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL,
rc_cur_time TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL,
rc_user INT DEFAULT 0   NOT NULL,
rc_user_text VARCHAR(255) DEFAULT ''   NOT NULL,
rc_namespace INT DEFAULT 0   NOT NULL,
rc_title VARCHAR(255) DEFAULT ''   NOT NULL,
rc_comment VARCHAR(255) DEFAULT ''   NOT NULL,
rc_minor SMALLINT DEFAULT 0   NOT NULL,
rc_bot SMALLINT DEFAULT 0   NOT NULL,
rc_new SMALLINT DEFAULT 0   NOT NULL,
rc_cur_id INT DEFAULT 0   NOT NULL,
rc_this_oldid INT DEFAULT 0   NOT NULL,
rc_last_oldid INT DEFAULT 0   NOT NULL,
rc_type SMALLINT DEFAULT 0   NOT NULL,
rc_moved_to_ns SMALLINT DEFAULT 0   NOT NULL,
rc_moved_to_title VARCHAR(255) DEFAULT ''   NOT NULL,
rc_patrolled SMALLINT DEFAULT 0   NOT NULL,
rc_ip CHAR(15) DEFAULT ''   NOT NULL,
rc_old_len INT DEFAULT 0  ,
rc_new_len INT DEFAULT 0  ,
rc_deleted SMALLINT DEFAULT 0   NOT NULL,
rc_logid INT DEFAULT 0   NOT NULL,
rc_log_type STRING DEFAULT ''   NOT NULL,
rc_log_action STRING DEFAULT ''   NOT NULL,
rc_params STRING DEFAULT ''   NOT NULL
 ) 
;
CREATE SERIAL /*$wgDBprefix*/rc_rc_id_seq START WITH 1;

CREATE TABLE /*$wgDBprefix*/redirect
( rd_from INT DEFAULT 0   NOT NULL,
rd_namespace INT DEFAULT 0   NOT NULL,
rd_title VARCHAR(255) DEFAULT ''   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/revision
( rev_id INT DEFAULT 0   NOT NULL,
rev_page INT DEFAULT 0   NOT NULL,
rev_text_id INT DEFAULT 0   NOT NULL,
rev_comment STRING DEFAULT ''   NOT NULL,
rev_user INT DEFAULT 0   NOT NULL,
rev_user_text VARCHAR(255) DEFAULT ''   NOT NULL,
rev_timestamp TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL,
rev_minor_edit SMALLINT DEFAULT 0   NOT NULL,
rev_deleted SMALLINT DEFAULT 0   NOT NULL,
rev_len INT DEFAULT 0  ,
rev_parent_id INT DEFAULT 0  
 ) 
;
CREATE SERIAL /*$wgDBprefix*/rev_rev_id_val START WITH 1;

CREATE TABLE /*$wgDBprefix*/searchindex
( si_page INT DEFAULT 0   NOT NULL,
si_title VARCHAR(255) DEFAULT ''   NOT NULL,
si_text STRING DEFAULT ''   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/site_stats
( ss_row_id INT DEFAULT 0   NOT NULL,
ss_total_views NUMERIC DEFAULT 0  ,
ss_total_edits NUMERIC DEFAULT 0  ,
ss_good_articles NUMERIC DEFAULT 0  ,
ss_total_pages NUMERIC DEFAULT -1  ,
ss_users NUMERIC DEFAULT -1  ,
ss_admins INT DEFAULT -1  ,
ss_images INT DEFAULT 0  
 ) 
;

CREATE TABLE /*$wgDBprefix*/templatelinks
( tl_from INT DEFAULT 0   NOT NULL,
tl_namespace INT DEFAULT 0   NOT NULL,
tl_title VARCHAR(255) DEFAULT ''   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/text
( old_id INT DEFAULT 0   NOT NULL,
old_text STRING DEFAULT ''   NOT NULL,
old_flags STRING DEFAULT ''   NOT NULL
 ) 
;
CREATE SERIAL /*$wgDBprefix*/text_old_id_val  START WITH 1;

CREATE TABLE /*$wgDBprefix*/trackbacks
( tb_id INT DEFAULT 0   NOT NULL,
tb_page INT DEFAULT 0  ,
tb_title VARCHAR(255) DEFAULT ''   NOT NULL,
tb_url VARCHAR(255) DEFAULT ''   NOT NULL,
tb_ex VARCHAR(65535) DEFAULT ''  ,
tb_name VARCHAR(255) DEFAULT ''  
 ) 
;
CREATE SERIAL /*$wgDBprefix*/trackbacks_tb_id_seq START WITH 1;

CREATE TABLE /*$wgDBprefix*/transcache
( tc_url VARCHAR(255) DEFAULT ''   NOT NULL,
tc_contents VARCHAR(65535) DEFAULT ''  ,
tc_time INT DEFAULT 0   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/mwuser
( user_id INT DEFAULT 0   NOT NULL,
user_name VARCHAR(255) DEFAULT ''   NOT NULL,
user_real_name VARCHAR(255) DEFAULT ''   NOT NULL,
user_password STRING DEFAULT ''   NOT NULL,
user_newpassword STRING DEFAULT ''   NOT NULL,
user_newpass_time TIMESTAMP,
user_email VARCHAR(256) DEFAULT ''   NOT NULL,
user_options STRING DEFAULT ''   NOT NULL,
user_touched TIMESTAMP DEFAULT timestamp'00:00:00 AM 01/02/1970' NOT NULL,
user_token CHAR(32) DEFAULT ''   NOT NULL,
user_email_authenticated TIMESTAMP,
user_email_token CHAR(32) DEFAULT ''  ,
user_email_token_expires TIMESTAMP ,
user_registration TIMESTAMP,
user_editcount INT DEFAULT 0  
 ) 
;
CREATE SERIAL /*$wgDBprefix*/user_user_id_seq START WITH 1;

CREATE TABLE /*$wgDBprefix*/user_groups
( ug_user INT DEFAULT 0   NOT NULL,
ug_group CHAR(16) DEFAULT ''   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/user_newtalk
( user_id INT DEFAULT 0   NOT NULL,
user_ip VARCHAR(40) DEFAULT ''   NOT NULL
 ) 
;

CREATE TABLE /*$wgDBprefix*/watchlist
( wl_user INT DEFAULT 0   NOT NULL,
wl_namespace INT DEFAULT 0   NOT NULL,
wl_title VARCHAR(255) DEFAULT ''   NOT NULL,
wl_notificationtimestamp TIMESTAMP 
 ) 
;


CREATE  INDEX name_title_timestamp_idx on /*$wgDBprefix*/archive (  ar_namespace  ,ar_title  ,ar_timestamp )
 ;
CREATE UNIQUE INDEX cl_from_idx on /*$wgDBprefix*/categorylinks (  cl_from  ,cl_to )
 ;
CREATE  INDEX cl_sortkey_idx on /*$wgDBprefix*/categorylinks (  cl_to  ,cl_sortkey )
 ;
CREATE  INDEX cl_timestamp_idx on /*$wgDBprefix*/categorylinks (  cl_to  ,cl_timestamp )
 ;
CREATE  INDEX el_from_idx on /*$wgDBprefix*/externallinks (  el_from  ,el_to )
 ;
CREATE  INDEX el_to_idx on /*$wgDBprefix*/externallinks (  el_to  ,el_from )
 ;
CREATE  INDEX el_index_idx on /*$wgDBprefix*/externallinks (  el_index )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/filearchive (  fa_id )
 ;
CREATE  INDEX fa_name_idx on /*$wgDBprefix*/filearchive (  fa_name  ,fa_timestamp )
 ;
CREATE  INDEX fa_storage_group_idx on /*$wgDBprefix*/filearchive (  fa_storage_group  ,fa_storage_key )
 ;
CREATE  INDEX fa_deleted_timestamp_idx on /*$wgDBprefix*/filearchive (  fa_deleted_timestamp )
 ;
CREATE  INDEX fa_deleted_user_idx on /*$wgDBprefix*/filearchive (  fa_deleted_user )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/imagebase (  img_name )
 ;
CREATE  INDEX img_size_idx on /*$wgDBprefix*/imagebase (  img_size )
 ;
CREATE  INDEX img_timestamp_idx on /*$wgDBprefix*/imagebase (  img_timestamp )
 ;
CREATE UNIQUE INDEX il_from_idx on /*$wgDBprefix*/imagelinks (  il_from  ,il_to )
 ;
CREATE  INDEX il_to_idx on /*$wgDBprefix*/imagelinks (  il_to  ,il_from )
 ;
CREATE UNIQUE INDEX iw_prefix_idx on /*$wgDBprefix*/interwiki (  iw_prefix )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/ipblocks (  ipb_id )
 ;
CREATE UNIQUE INDEX ipb_address_idx on /*$wgDBprefix*/ipblocks (  ipb_address  ,ipb_user  ,ipb_auto  ,ipb_anon_only )
 ;
CREATE  INDEX ipb_user_idx on /*$wgDBprefix*/ipblocks (  ipb_user )
 ;
CREATE  INDEX ipb_range_idx on /*$wgDBprefix*/ipblocks (  ipb_range_start  ,ipb_range_end )
 ;
CREATE  INDEX ipb_timestamp_idx on /*$wgDBprefix*/ipblocks (  ipb_timestamp )
 ;
CREATE  INDEX ipb_expiry_idx on /*$wgDBprefix*/ipblocks (  ipb_expiry )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/job (  job_id )
 ;
CREATE  INDEX job_cmd_idx on /*$wgDBprefix*/job (  job_cmd  ,job_namespace  ,job_title )
 ;
CREATE UNIQUE INDEX ll_from_idx on /*$wgDBprefix*/langlinks (  ll_from  ,ll_lang )
 ;
CREATE  INDEX ll_lang_idx on /*$wgDBprefix*/langlinks (  ll_lang  ,ll_title )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/logging (  log_id )
 ;
CREATE  INDEX type_time_idx on /*$wgDBprefix*/logging (  log_type  ,log_timestamp )
 ;
CREATE  INDEX user_time_idx on /*$wgDBprefix*/logging (  log_user  ,log_timestamp )
 ;
CREATE  INDEX page_time_idx on /*$wgDBprefix*/logging (  log_namespace  ,log_title  ,log_timestamp )
 ;
CREATE  INDEX times_idx on /*$wgDBprefix*/logging (  log_timestamp )
 ;
CREATE UNIQUE INDEX math_inputhash_idx on /*$wgDBprefix*/math (  math_inputhash )
 ;
CREATE UNIQUE INDEX keyname_idx on /*$wgDBprefix*/objectcache (  keyname )
 ;
CREATE  INDEX exptime_idx on /*$wgDBprefix*/objectcache (  exptime )
 ;
CREATE  INDEX oi_name_idx on /*$wgDBprefix*/oldimage (  oi_name )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/page (  page_id )
 ;
CREATE UNIQUE INDEX name_title on /*$wgDBprefix*/page (  page_namespace  ,page_title )
 ;
CREATE  INDEX page_random on /*$wgDBprefix*/page (  page_random )
 ;
CREATE  INDEX page_len on /*$wgDBprefix*/page (  page_len )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/page_restrictions (  pr_page  ,pr_type )
 ;
CREATE UNIQUE INDEX pr_id_idx on /*$wgDBprefix*/page_restrictions (  pr_id )
 ;
CREATE  INDEX pr_page_idx on /*$wgDBprefix*/page_restrictions (  pr_page )
 ;
CREATE  INDEX pr_typelevel_idx on /*$wgDBprefix*/page_restrictions (  pr_type  ,pr_level )
 ;
CREATE  INDEX pr_level_idx on /*$wgDBprefix*/page_restrictions (  pr_level )
 ;
CREATE  INDEX pr_cascade_idx on /*$wgDBprefix*/page_restrictions (  pr_cascade )
 ;
CREATE UNIQUE INDEX pl_from_idx on /*$wgDBprefix*/pagelinks (  pl_from  ,pl_namespace  ,pl_title )
 ;
CREATE  INDEX pl_namespace_idx on /*$wgDBprefix*/pagelinks (  pl_namespace  ,pl_title  ,pl_from )
 ;
CREATE  INDEX qc_type_idx on /*$wgDBprefix*/querycache (  qc_type  ,qc_value )
 ;
CREATE UNIQUE INDEX qci_type_idx on /*$wgDBprefix*/querycache_info (  qci_type )
 ;
CREATE  INDEX qcc_type_idx on /*$wgDBprefix*/querycachetwo (  qcc_type  ,qcc_value )
 ;
CREATE  INDEX qcc_title_idx on /*$wgDBprefix*/querycachetwo (  qcc_type  ,qcc_namespace  ,qcc_title )
 ;
CREATE  INDEX qcc_titletwo_idx on /*$wgDBprefix*/querycachetwo (  qcc_type  ,qcc_namespacetwo  ,qcc_titletwo )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/recentchanges (  rc_id )
 ;
CREATE  INDEX rc_timestamp on /*$wgDBprefix*/recentchanges (  rc_timestamp )
 ;
CREATE  INDEX rc_namespace_title_idx on /*$wgDBprefix*/recentchanges (  rc_namespace  ,rc_title )
 ;
CREATE  INDEX rc_cur_id_idx on /*$wgDBprefix*/recentchanges (  rc_cur_id )
 ;
CREATE  INDEX new_name_timestamp_idx on /*$wgDBprefix*/recentchanges (  rc_new  ,rc_namespace  ,rc_timestamp )
 ;
CREATE  INDEX rc_ip_idx on /*$wgDBprefix*/recentchanges (  rc_ip )
 ;
CREATE  INDEX rc_ns_usertext_idx on /*$wgDBprefix*/recentchanges (  rc_namespace  ,rc_user_text )
 ;
CREATE  INDEX rc_user_text_idx on /*$wgDBprefix*/recentchanges (  rc_user_text  ,rc_timestamp )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/redirect (  rd_from )
 ;
CREATE  INDEX rd_ns_title_idx on /*$wgDBprefix*/redirect (  rd_namespace  ,rd_title  ,rd_from )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/revision (  rev_page  ,rev_id )
 ;
CREATE UNIQUE INDEX rev_id_idx on /*$wgDBprefix*/revision (  rev_id )
 ;
CREATE  INDEX rev_timestamp_idx on /*$wgDBprefix*/revision (  rev_timestamp )
 ;
CREATE  INDEX page_timestamp on /*$wgDBprefix*/revision (  rev_page  ,rev_timestamp )
 ;
CREATE  INDEX user_timestamp on /*$wgDBprefix*/revision (  rev_user  ,rev_timestamp )
 ;
CREATE  INDEX usertext_timestamp on /*$wgDBprefix*/revision (  rev_user_text  ,rev_timestamp )
 ;
CREATE UNIQUE INDEX si_page_idx on /*$wgDBprefix*/searchindex (  si_page )
 ;
CREATE  INDEX si_title_idx on /*$wgDBprefix*/searchindex (  si_title )
 ;
CREATE  INDEX si_text_idx on /*$wgDBprefix*/searchindex (  si_text )
 ;
CREATE UNIQUE INDEX ss_row_id_idx on /*$wgDBprefix*/site_stats (  ss_row_id )
 ;
CREATE UNIQUE INDEX tl_from_idx on /*$wgDBprefix*/templatelinks (  tl_from  ,tl_namespace  ,tl_title )
 ;
CREATE  INDEX tl_namespace_idx on /*$wgDBprefix*/templatelinks (  tl_namespace  ,tl_title  ,tl_from )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/text (  old_id )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/trackbacks (  tb_id )
 ;
CREATE  INDEX tb_page_idx on /*$wgDBprefix*/trackbacks (  tb_page )
 ;
CREATE UNIQUE INDEX tc_url_idx_idx on /*$wgDBprefix*/transcache (  tc_url )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/mwuser (  user_id )
 ;
CREATE UNIQUE INDEX user_name_idx on /*$wgDBprefix*/mwuser (  user_name )
 ;
CREATE  INDEX user_email_token_idx on /*$wgDBprefix*/mwuser (  user_email_token )
 ;
CREATE UNIQUE INDEX PRIMARY_idx on /*$wgDBprefix*/user_groups (  ug_user  ,ug_group )
 ;
CREATE  INDEX ug_group_idx on /*$wgDBprefix*/user_groups (  ug_group )
 ;
CREATE  INDEX user_id_idx on /*$wgDBprefix*/user_newtalk (  user_id )
 ;
CREATE  INDEX user_ip_idx on /*$wgDBprefix*/user_newtalk (  user_ip )
 ;
CREATE UNIQUE INDEX wl_user_idx on /*$wgDBprefix*/watchlist (  wl_user  ,wl_namespace  ,wl_title )
 ;
CREATE  INDEX namespace_title_idx on /*$wgDBprefix*/watchlist (  wl_namespace  ,wl_title )
 ;

CREATE TABLE /*$wgDBprefix*/serial_base ( a int ) ;
INSERT INTO /*$wgDBprefix*/serial_base VALUES (1) ;

COMMIT WORK;